class A
{
	field = null;
}

class B
{
	field = null;
}

class TEST extends AIController 
{
}

function TEST::Start()
{
	AIRail.SetCurrentRailType(AIRailTypeList().Begin())

	local depot_tile = AIMap.GetTileIndex(1, 1);
	local b = AIMap.GetTileIndex(2, 1);
	
	if(!AIRail.BuildRailDepot(depot_tile, b)){
		AILog.Error(AIError.GetLastErrorString());
		AILog.Error("unable to make depot in top of the map");
		return;
	}

	makeEngine(depot_tile);

	local cargo_list_a = AICargoList();
	local cargo_list_b = AICargoList();
	for (local cargo_a = cargo_list_a.Begin(); !cargo_list_a.IsEnd(); cargo_a = cargo_list_a.Next()) {
		for (local cargo_b = cargo_list_b.Begin(); !cargo_list_b.IsEnd(); cargo_b = cargo_list_b.Next()) {
			if(cargo_a != cargo_b) {
				testWagon(depot_tile, cargo_a, cargo_b);
			}
		}
	}
}

function makeEngine(depot_tile){
	local engines = AIEngineList(AIVehicle.VT_RAIL);
	engines.Valuate(AIEngine.IsWagon);
	engines.RemoveValue(1);
	engines.Valuate(AIEngine.CanRunOnRail, AIRail.GetCurrentRailType());
	engines.RemoveValue(0);
	engines.Valuate(AIEngine.IsBuildable);
	engines.RemoveValue(0);
	engines.Valuate(AIEngine.GetPrice);
	engines.Sort(AIList.SORT_BY_VALUE, true);
	if(engines.Count() == 0){
		AIlog.Error("No available engines!");
		return;
	}

	if(!AIVehicle.BuildVehicle(depot_tile, engines.Begin())){
		AILog.Error("cheapest engine construction failed.");
	} else {
		AILog.Info(AIEngine.GetName(engines.Begin()) + " made")
	}
}

function testWagon(depot_tile, cargo_a, cargo_b) {
	local wagon = getWagon(cargo_a, cargo_b);

	if(wagon == null){
		return;
	} else {
		AILog.Info(AIEngine.GetName(wagon));
		AIController.Sleep(5);	
	}

	local newWagon = AIVehicle.BuildVehicle(depot_tile, wagon);

	if (AIVehicle.GetCapacity(newWagon, cargo_b) > 0) {
		local swap = cargo_b;
		cargo_b = cargo_a;
		cargo_a = swap;
	}

	if (AIVehicle.GetCapacity(newWagon, cargo_b) > 0) {
		return;
	}

	AILog.Info("cargo_b capacity before refit: " + AIVehicle.GetCapacity(newWagon, cargo_b));
	local returned = RefitVehicle(newWagon, cargo_b);

	AILog.Info("AIVehicle.RefitVehicle returned "+returned+" with "+AIError.GetLastErrorString());	
	AILog.Info("cargo_b capacity after refit: " + AIVehicle.GetCapacity(newWagon, cargo_b));
	//AIVehicle.SellVehicle(newWagon)
}

function getWagon(cargo_a, cargo_b){
	local wagons = AIEngineList(AIVehicle.VT_RAIL);
	wagons.Valuate(AIEngine.IsWagon);
	wagons.RemoveValue(0);
	wagons.Valuate(AIEngine.IsBuildable);
	wagons.RemoveValue(0);
	wagons.Valuate(AIEngine.CanRefitCargo, cargo_a);
	wagons.RemoveValue(0);
	wagons.Valuate(AIEngine.CanRefitCargo, cargo_b);
	wagons.RemoveValue(0);
	wagons.Valuate(AIEngine.CanRunOnRail, AIRail.GetCurrentRailType());
	wagons.RemoveValue(0);
	if(wagons.Count() == 0){
		return null;
	}
	return wagons.Begin();
}

function RefitVehicle(vehicle, cargo){
	if(!AIVehicle.IsValidVehicle(vehicle)){
		AILog.Error("IsValidVehicle");
	}

	if(!AICargo.IsValidCargo(cargo)){
		AILog.Error("IsValidCargo");
	}

	if(!AIVehicle.IsStoppedInDepot(vehicle)){
		AILog.Error("IsStoppedInDepot");
	}
	//AILog.Warning(vehicle);
	return AIVehicle.RefitVehicle(vehicle, cargo);
}